From: Stefano Zacchiroli <zack@debian.org>
Date: Sat, 3 Jul 2010 18:35:28 +0200
Subject: Makefiles fixes

Patch upstream Makefiles in order to:
 - install stuff properly in debian/ subdirs
 - built native code stuff only if ocamlopt is available
 - install camlidlruntime.h header in /usr/include/ocaml/<version>/

Author: Stefano Zacchiroli <zack@debian.org>
---
 Makefile              |  3 +++
 config/Makefile.unix  |  2 +-
 lib/Makefile          | 14 +++++++++++---
 runtime/Makefile.unix |  8 ++++----
 4 files changed, 19 insertions(+), 8 deletions(-)

diff --git a/Makefile b/Makefile
index d0db8d9..80dde0e 100644
--- a/Makefile
+++ b/Makefile
@@ -20,6 +20,9 @@ all:
 	cd lib; $(MAKE) all
 	cd tools; $(MAKE) all
 
+opt:
+	cd lib; $(MAKE) opt
+
 install:
 	cd compiler; $(MAKE) install
 	cd runtime; $(MAKE) install
diff --git a/config/Makefile.unix b/config/Makefile.unix
index 9d769e9..d36d128 100644
--- a/config/Makefile.unix
+++ b/config/Makefile.unix
@@ -34,7 +34,7 @@ RANLIB=ranlib
 OCAMLLIB=$(shell $(OCAMLC) -where)
 
 # Where to install the binaries
-BINDIR=/usr/local/bin
+BINDIR=$(DESTDIR)/usr/bin
 
 # The Objective Caml compilers (the defaults below should be OK)
 OCAMLC=ocamlc -g
diff --git a/lib/Makefile b/lib/Makefile
index 5048be6..e8e3fba 100644
--- a/lib/Makefile
+++ b/lib/Makefile
@@ -20,7 +20,9 @@ NATIVEOBJS=$(BYTEOBJS:.cmo=.cmx)
 NATIVELIB=$(BYTELIB:.cma=.cmxa)
 INTERFACES=$(BYTEOBJS:.cmo=.cmi)
 
-all: $(BYTELIB) $(NATIVELIB)
+all: $(BYTELIB)
+
+opt: $(NATIVELIB)
 
 $(BYTELIB): $(BYTEOBJS)
 	$(OCAMLC) -a -o $(BYTELIB) -dllib -lcamlidl -cclib -lcamlidl $(BYTEOBJS)
@@ -29,8 +31,14 @@ $(NATIVELIB): $(NATIVEOBJS)
 	$(OCAMLOPT) -a -o $(NATIVELIB) -cclib -lcamlidl $(NATIVEOBJS)
 
 install:
-	cp $(INTERFACES) $(BYTELIB) $(NATIVELIB) $(NATIVELIB:.cmxa=.$(LIBEXT)) $(OCAMLLIB)
-	cd $(OCAMLLIB); $(RANLIB) $(NATIVELIB:.cmxa=.$(LIBEXT))
+	cp $(INTERFACES) $(BYTELIB) $(DESTDIR)$(OCAMLLIB)
+	if [ -x /usr/bin/ocamlopt ]; then	\
+		cp $(NATIVELIB) $(NATIVELIB:.cmxa=.$(LIBEXT)) $(DESTDIR)$(OCAMLLIB);	\
+		cd $(DESTDIR)$(OCAMLLIB);	\
+		$(RANLIB) $(NATIVELIB:.cmxa=.$(LIBEXT));	\
+	else	\
+		true;	\
+	fi
 
 .SUFFIXES: .mli .ml .cmi .cmo .cmx
 
diff --git a/runtime/Makefile.unix b/runtime/Makefile.unix
index d51d6bb..6ee4812 100644
--- a/runtime/Makefile.unix
+++ b/runtime/Makefile.unix
@@ -26,10 +26,10 @@ dllcamlidl.so libcamlidl.a: $(OBJS)
 #	$(RANLIB) $@
 
 install:
-	cp camlidlruntime.h $(OCAMLLIB)/caml/camlidlruntime.h
-	cp libcamlidl.a $(OCAMLLIB)/libcamlidl.a
-	cp dllcamlidl.so $(OCAMLLIB)/stublibs/dllcamlidl.so
-	cd $(OCAMLLIB); $(RANLIB) libcamlidl.a
+	cp camlidlruntime.h $(DESTDIR)$(OCAMLLIB)/caml/camlidlruntime.h
+	cp libcamlidl.a $(DESTDIR)$(OCAMLLIB)/libcamlidl.a
+	cp dllcamlidl.so $(DESTDIR)$(OCAMLLIB)/stublibs/dllcamlidl.so
+	cd $(DESTDIR)$(OCAMLLIB); $(RANLIB) libcamlidl.a
 
 clean:
 	rm -f *.a *.o *.so
